(defun c:roof-new ( / *error* unit rlw offd inside-p collinear-p unique chkcircinside subprocess process done lw lwi lwx ent enti lil lix lwnl ch el p1 p2 pp ppp ipp ippl vll vlli tll ) ;;; cad, doc, spc, lay - global variables ;;;

  (vl-load-com)

  (defun *error* ( m )
    (if (and lwi (not (vlax-erased-p lwi)))
      (entdel lwi)
    )
    (if (and enti (not (vlax-erased-p enti)))
      (entdel enti)
    )
    (if (setq ppp (unique ppp))
      (foreach pp ppp
        (if (not (vl-some '(lambda ( x ) (and (not (equal (car x) pp 1e-6)) (not (equal (cadr x) pp 1e-6)) (not (equal (car x) (cadr x) 1e-6)) (collinear-p (car x) pp (cadr x)))) lil))
          (entmake (list (cons 0 "POINT") (cons 10 pp) (cons 62 1)))
        )
      )
    )
    (if (= ch "No")
      (while (setq el (entnext el))
        (if (and el (not (vlax-erased-p el)))
          (entdel el)
        )
      )
    )
    (if lil
      (foreach li lil
        (if (vl-some '(lambda ( x ) (and (not (equal (car li) x 1e-6)) (not (equal (cadr li) x 1e-6)) (not (equal (car li) (cadr li) 1e-6)) (collinear-p (car li) x (cadr li)))) ppp)
          (setq lil (vl-remove li lil))
          (if (vl-some '(lambda ( x ) (equal x (car li) 1e-6)) ppp)
            (entmake (list (cons 0 "LINE") (cons 10 (car li)) (cons 11 (cadr li)) (cons 62 3)))
          )
        )
      )
    )
    (command-s "_.-OVERKILL" "_ALL" "_T" "_Y" "" "")
    (if (= 8 (logand 8 (getvar 'undoctl)))
      (vla-endundomark doc)
    )
    (if m
      (prompt m)
    )
    (princ)
  )

  (defun unit ( v / d )
    (if (not (equal (setq d (distance '(0.0 0.0 0.0) v)) 0.0 1e-6))
      (mapcar '(lambda ( x ) (/ x d)) v)
    )
  )

  (defun rlw ( lw / e x1 x2 x3 x4 x5 x6 )
    ;; by ElpanovEvgeniy
    (if (= (cdr (assoc 0 (setq e (entget lw)))) "LWPOLYLINE")
      (progn
        (foreach a1 e
          (cond ((= (car a1) 10) (setq x2 (cons a1 x2)))
                ((= (car a1) 40) (setq x4 (cons (cons 41 (cdr a1)) x4)))
                ((= (car a1) 41) (setq x3 (cons (cons 40 (cdr a1)) x3)))
                ((= (car a1) 42) (setq x5 (cons (cons 42 (- (cdr a1))) x5)))
                ((= (car a1) 210) (setq x6 (cons a1 x6)))
                (t (setq x1 (cons a1 x1)))
          )
        )
        (entmod (append (reverse x1)
                  (append (apply 'append
                            (apply 'mapcar
                              (cons 'list
                                (list x2
                                  (cdr (reverse (cons (car x3) (reverse x3))))
                                  (cdr (reverse (cons (car x4) (reverse x4))))
                                  (cdr (reverse (cons (car x5) (reverse x5))))
                                )
                              )
                            )
                          )
                          x6
                  )
                )
        )
        (entupd lw)
      )
    )
  )

  (defun offd ( ip tl / dl )
    (setq dl (mapcar '(lambda ( x )
                        (distance ip
                          (inters
                            ip
                            (polar ip (+ (* 0.5 pi) (angle (car x) (cadr x))) 1.0)
                            (car x)
                            (polar (car x) (angle (car x) (cadr x)) 1.0)
                            nil
                          )
                        )
                      ) tl
              )
    )
    (vl-some '(lambda ( x )
               (if
                 (>
                   (-
                     (length dl)
                     (length (vl-remove-if '(lambda ( y ) (equal x y 1e-3)) dl))
                   ) 2
                 )
                 x
               )
             ) (vl-sort dl '<)
    )
  )

  (defun inside-p ( p lw lwi )
    (< (distance p (vlax-curve-getclosestpointto lwi p)) (distance p (vlax-curve-getclosestpointto lw p)))
  )

  (defun collinear-p ( p1 p p2 )
    (equal (distance p1 p2) (+ (distance p1 p) (distance p p2)) 1e-6)
  )

  (defun unique ( pl )
    (if pl
      (cons (car pl)
            (unique
              (vl-remove-if
                '(lambda ( x )
                   (equal x (car pl) 1e-6)
                 )
                (cdr pl)
              )
            )
      )
    )
  )

  (defun chkcircinside ( pp tll / d ci ipp ippl tst )
    (if (and pp tll (setq d (+ (offd pp tll) 5e-3)))
      (progn
        (setq ci (entmakex (list (cons 0 "CIRCLE") (cons 10 pp) (cons 40 d))))
        (if (setq ipp (vlax-invoke (vlax-ename->vla-object ci) 'intersectwith (vlax-ename->vla-object ent) acextendnone))
          (progn
            (while ipp
              (setq ippl (cons (list (car ipp) (cadr ipp) (caddr ipp)) ippl))
              (setq ipp (cdddr ipp))
            )
            (if (vl-every '(lambda ( x ) (inside-p x ent enti)) (apply 'append (mapcar '(lambda ( x ) (list (vlax-curve-getpointatparam ci (- x 0.1)) (vlax-curve-getpointatparam ci (+ x 0.1)))) (mapcar '(lambda ( x ) (vlax-curve-getparamatpoint ci x)) ippl))))
              (setq tst t)
            )
          )
        )
        (if (and ci (not (vlax-erased-p ci)))
          (entdel ci)
        )
      )
    )
    tst
  )

  (defun subprocess ( sign vl vll vli vlli tl tll lwi )
    (setq iplst (mapcar '(lambda ( p1 p2 p3 p4 / ip )
                          (if
                            (and
                              (setq ip (inters p1 p2 p3 p4 nil))
                              (inside-p ip lw lwi)
                              (chkcircinside ip tll)
                            )
                            (list ip (list p1 p3))
                            (list nil nil)
                          )
                        )
                        vl
                        vli
                        (append (cdr vl) (list (car vl)))
                        (append (cdr vli) (list (car vli)))
                )
    )
    (setq iplstoffd (vl-remove-if '(lambda ( y ) (null (caddr y)))
                      (mapcar '(lambda ( x ) (if (car x)
                                               (list (car x) (cadr x) (offd (car x) tl))
                                               (list nil nil nil)
                                             )
                               ) (vl-remove-if '(lambda ( x ) (and (null (car x)) (null (cadr x)))) iplst)
                      )
                    )
    )
    (foreach ipd (setq iplstoffd (vl-sort iplstoffd '(lambda ( a b ) (sign (caddr a) (caddr b)))))
      (if ipd
        (progn
          (setq ppp (cons (car ipd) ppp))
          (if
            (setq p1
              (vl-some '(lambda ( x )
                (if
                  (equal
                    (unit (mapcar '- (car ipd) x))
                    (unit (mapcar '- (car ipd) (caadr ipd)))
                    1e-6
                  )
                  x
                )
              ) vll
              )
            )
            (setq lil (cons (list (car ipd) p1) lil))
            (setq lil (cons (list (car ipd) (caadr ipd)) lil))
          )
          (if
            (setq p2
              (vl-some '(lambda ( x )
                (if
                  (equal
                    (unit (mapcar '- (car ipd) x))
                    (unit (mapcar '- (car ipd) (cadadr ipd)))
                    1e-6
                  )
                  x
                )
              ) vll
              )
            )
            (setq lil (cons (list (car ipd) p2) lil))
            (setq lil (cons (list (car ipd) (cadadr ipd)) lil))
          )
          (if
            (and
              (caddr ipd)
              (not (vl-catch-all-error-p 
                (setq lwnl (vl-catch-all-apply
                 'vlax-invoke
                  (list (vlax-ename->vla-object lw) 'offset (- (caddr ipd)))))))
            )
            (if (not (caddr ipd))
              (progn
                (setq ipd (list (car ppp) nil (offd (car ppp) tll)))
                (not (vl-catch-all-error-p 
                (setq lwnl (vl-catch-all-apply
                 'vlax-invoke
                  (list (vlax-ename->vla-object ent) 'offset (- (caddr ipd)))))))
              )
            )
          )
          (mapcar 'vlax-vla-object->ename lwnl)
        )
      )
    )
  )

  (defun process ( lw / lwi lwx vl vli iplst tl ipd iplstoffd p1 p2 pp lwnl ) ;;; vll ; vlli ; tll ; lwnl ; ppp - lexical global variables ;;;
    (if lw
      (progn
        (setq vl (mapcar 'cdr (vl-remove-if '(lambda ( x ) (/= (car x) 10)) (setq lwx (entget lw)))))
        (if (not vll)
          (setq vll vl)
        )
        (setq lwi (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object lw) 'offset -1e-3))))
        (setq vli (mapcar 'cdr (vl-remove-if '(lambda ( x ) (/= (car x) 10)) (entget lwi))))
        (if (not vlli)
          (setq vlli vli)
        )
        (setq tl (mapcar '(lambda ( a b ) (list a b)) vl (append (cdr vl) (list (car vl)))))
        (if (not tll)
          (setq tll tl)
        )
        (subprocess < vl vll vli vlli tl tll lwi)
        (if (and lwi (not (vlax-erased-p lwi)))
          (entdel lwi)
        )
        lwnl
      )
    )
  )

  (or cad (progn (vl-load-com) (setq cad (vlax-get-acad-object))))
  (or doc (setq doc (vla-get-activedocument cad)))
  (or spc (setq spc (vla-get-block (setq lay (vla-get-activelayout doc)))))

  (if (= 8 (logand 8 (getvar 'undoctl)))
    (vla-endundomark doc)
  )
  (vla-startundomark doc)
  (if
    (and
      (setq lw (car (entsel "\nPick boundary closed polygonal LWPOLYLINE with only straight segments...")))
      (= (cdr (assoc 0 (setq lwx (entget lw)))) "LWPOLYLINE")
      (= 1 (logand 1 (cdr (assoc 70 lwx))))
      (vl-every '(lambda ( x ) (= 0.0 (cdr x))) (vl-remove-if '(lambda ( x ) (/= (car x) 42)) lwx))
      (setq el (entlast) ent lw)
    )
    (progn
      (setq lwi (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object lw) 'offset -1e-3))))
      (if (> (vlax-curve-getarea lwi) (vlax-curve-getarea lw))
        (setq lw (rlw lw)) ;;; force main lwpolyline CCW - counter clockwise ;;;
      )
      (setq enti (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object ent) 'offset -1e-3))))
      (if (and lwi (not (vlax-erased-p lwi)))
        (entdel lwi)
      )
      (initget "Yes No")
      (setq ch (cond ((getkword "\nDo you want points-offsets-lines or just lines [Yes / No] <Yes> - there are some lacks with just lines, so HIT ENTER : ")) ( "Yes" )))
      (while
        (and
          (not done)
          (not (vl-catch-all-error-p (setq lwnl (vl-catch-all-apply 'process (list lw)))))
        )
        (foreach lww lwnl
          (if (vl-catch-all-error-p (setq lwnl (vl-catch-all-apply 'process (list lww))))
            (setq done t)
          )
        )
        (if (vl-catch-all-error-p lwnl)
          (setq done t)
        )
      ) ;;; main engine - iteration ;;;
    )
  )
  (*error* nil)
)
